import enum


class Product(enum.Enum):
    PRIVATE_EQUITY = "pe"
    PRIVATE_INFRA = "pi"

class App(enum.Enum):
    MARKET_INDICES = "indices"
    THEMATIC_INDICES = "valuation"

class Taxonomy(enum.Enum):
    TICCS = "ticcs"
    PECCS = "peccs"
    TICCS_PLUS = "ticcs+"
    TICCS_TO_NACE = "ticcs-nace"
    TICCS_TO_EU = "ticcs-eu"

class Ticcs(enum.Enum):
    INDUSTRIAL_ACTIVITY = "industrialActivity"
    BUSINESS_MODEL = "businessRisk"
    CORPORATE_STRUCTURE = "corporateStructure"
    GEO_ECONOMIC_EXPOSURE = "geoEconomicExposure"

class TiccsPlus(enum.Enum):
    ENVIRONMENT = "environment"
    GOVERNANCE = "governance"
    SOCIAL = "social"

class Peccs(enum.Enum):
    INDUSTRIAL_ACTIVITY = "activityClass"
    REVENUE_MODEL = "revenueModel"
    CUSTOMER_MODEL = "customerModel"
    LIFECYCLE_PHASE = "lifecyclePhase"
    VALUE_CHAIN_TYPE = "valueChainType"


class CriteriaAggregationType(enum.Enum):
    AND = " & "
    OR = " | "

IDENTIFIER = "SIPAMetrics"

TIME_TO_MATURITY_BUCKETS = {
    "T1": "<5",
    "T2": "5-10",
    "T3": "10-15",
    "T4": "15-20",
    "T5": ">20",
}

CURRENCY_MAP = {
    "USD": 840,
    "EUR": 978,
    "GBP": 826,
    "AED": 784,
    "AFN": 971,
    "ALL": 8,
    "AMD": 51,
    "ANG": 532,
    "AOA": 973,
    "ARS": 32,
    "ATS": 40,
    "AUD": 36,
    "AWG": 533,
    "AZN": 944,
    "BAM": 977,
    "BBD": 52,
    "BDT": 50,
    "BEF": 56,
    "BGN": 975,
    "BHD": 48,
    "BIF": 108,
    "BMD": 60,
    "BND": 96,
    "BOB": 68,
    "BOV": 984,
    "BRL": 986,
    "BSD": 44,
    "BTN": 64,
    "BWP": 72,
    "BYR": 974,
    "BZD": 84,
    "CAD": 124,
    "CDF": 976,
    "CHE": 947,
    "CHF": 756,
    "CHW": 948,
    "CLF": 990,
    "CLP": 152,
    "CNY": 156,
    "COP": 170,
    "COU": 970,
    "CRC": 188,
    "CUC": 931,
    "CUP": 192,
    "CVE": 132,
    "CZK": 203,
    "DEM": 276,
    "DJF": 262,
    "DKK": 208,
    "DOP": 214,
    "DZD": 12,
    "EGP": 818,
    "ERN": 232,
    "ESP": 724,
    "ETB": 230,
    "FIM": 246,
    "FJD": 242,
    "FKP": 238,
    "FRF": 250,
    "GEL": 981,
    "GHS": 936,
    "GIP": 292,
    "GMD": 270,
    "GNF": 324,
    "GRD": 300,
    "GTQ": 320,
    "GYD": 328,
    "HKD": 344,
    "HNL": 340,
    "HRK": 191,
    "HTG": 332,
    "HUF": 348,
    "IDR": 360,
    "IEP": 372,
    "ILS": 376,
    "INR": 356,
    "IQD": 368,
    "IRR": 364,
    "ISK": 352,
    "ITL": 380,
    "JMD": 388,
    "JOD": 400,
    "JPY": 392,
    "KES": 404,
    "KGS": 417,
    "KHR": 116,
    "KMF": 174,
    "KPW": 408,
    "KRW": 410,
    "KWD": 414,
    "KYD": 136,
    "KZT": 398,
    "LAK": 418,
    "LBP": 422,
    "LCU": 991,
    "LKR": 144,
    "LRD": 430,
    "LSL": 426,
    "LUF": 442,
    "LYD": 434,
    "MAD": 504,
    "MDL": 498,
    "MGA": 969,
    "MKD": 807,
    "MMK": 104,
    "MNT": 496,
    "MOP": 446,
    "MRO": 478,
    "MUR": 480,
    "MVR": 462,
    "MWK": 454,
    "MXN": 484,
    "MXV": 979,
    "MYR": 458,
    "MZN": 943,
    "NAD": 516,
    "NGN": 566,
    "NIO": 558,
    "NLG": 528,
    "NOK": 578,
    "NPR": 524,
    "NZD": 554,
    "OMR": 512,
    "PAB": 590,
    "PEN": 604,
    "PGK": 598,
    "PHP": 608,
    "PKR": 586,
    "PLN": 985,
    "PTE": 620,
    "PYG": 600,
    "QAR": 634,
    "RON": 946,
    "RSD": 941,
    "RUB": 643,
    "RWF": 646,
    "SAR": 682,
    "SBD": 90,
    "SCR": 690,
    "SDG": 938,
    "SEK": 752,
    "SGD": 702,
    "SHP": 654,
    "SLL": 694,
    "SOS": 706,
    "SRD": 968,
    "SSP": 728,
    "STD": 678,
    "SVC": 222,
    "SYP": 760,
    "SZL": 748,
    "THB": 764,
    "TJS": 972,
    "TMT": 934,
    "TND": 788,
    "TOP": 776,
    "TRY": 949,
    "TTD": 780,
    "TWD": 901,
    "TZS": 834,
    "UAH": 980,
    "UGX": 800,
    "UYI": 940,
    "UYU": 858,
    "UZS": 860,
    "VEF": 937,
    "VND": 704,
    "VUV": 548,
    "WST": 882,
    "XAF": 950,
    "XAG": 961,
    "XAU": 959,
    "XBA": 955,
    "XBB": 956,
    "XBC": 957,
    "XBD": 958,
    "XCD": 951,
    "XDR": 960,
    "XOF": 952,
    "XPD": 964,
    "XPF": 953,
    "XPT": 962,
    "XTS": 963,
    "XUA": 965,
    "YER": 886,
    "ZAR": 710,
    "ZMW": 967,
    "ZWL": 932,
}

COUNTRY_MAP = {
    "ABW": "533",
    "AFG": "4",
    "AGO": "24",
    "AIA": "660",
    "ALA": "248",
    "ALB": "8",
    "AND": "20",
    "ARE": "784",
    "ARG": "32",
    "ARM": "51",
    "ASM": "16",
    "ATA": "10",
    "ATF": "260",
    "ATG": "28",
    "AUS": "36",
    "AUT": "40",
    "AZE": "31",
    "BDI": "108",
    "BEL": "56",
    "BEN": "204",
    "BES": "535",
    "BFA": "854",
    "BGD": "50",
    "BGR": "100",
    "BHR": "48",
    "BHS": "44",
    "BIH": "70",
    "BLM": "652",
    "BLR": "112",
    "BLZ": "84",
    "BMU": "60",
    "BOL": "68",
    "BRA": "76",
    "BRB": "52",
    "BRN": "96",
    "BTN": "64",
    "BVT": "74",
    "BWA": "72",
    "CAF": "140",
    "CAN": "124",
    "CCK": "166",
    "CHE": "756",
    "CHL": "152",
    "CHN": "156",
    "CIV": "384",
    "CMR": "120",
    "COD": "180",
    "COG": "178",
    "COK": "184",
    "COL": "170",
    "COM": "174",
    "CPV": "132",
    "CRI": "188",
    "CUB": "192",
    "CUW": "531",
    "CXR": "162",
    "CYM": "136",
    "CYP": "196",
    "CZE": "203",
    "DEU": "276",
    "DJI": "262",
    "DMA": "212",
    "DNK": "208",
    "DOM": "214",
    "DZA": "12",
    "ECU": "218",
    "EGY": "818",
    "ERI": "232",
    "ESH": "732",
    "ESP": "724",
    "EST": "233",
    "ETH": "231",
    "FIN": "246",
    "FJI": "242",
    "FLK": "238",
    "FRA": "250",
    "FRO": "234",
    "FSM": "583",
    "GAB": "266",
    "GBR": "826",
    "GEO": "268",
    "GGY": "831",
    "GHA": "288",
    "GIB": "292",
    "GIN": "324",
    "GLP": "312",
    "GMB": "270",
    "GNB": "624",
    "GNQ": "226",
    "GRC": "300",
    "GRD": "308",
    "GRL": "304",
    "GTM": "320",
    "GUF": "254",
    "GUM": "316",
    "GUY": "328",
    "HKG": "344",
    "HMD": "334",
    "HND": "340",
    "HRV": "191",
    "HTI": "332",
    "HUN": "348",
    "IDN": "360",
    "IMN": "833",
    "IND": "356",
    "IOT": "86",
    "IRL": "372",
    "IRN": "364",
    "IRQ": "368",
    "ISL": "352",
    "ISR": "376",
    "ITA": "380",
    "JAM": "388",
    "JEY": "832",
    "JOR": "400",
    "JPN": "392",
    "KAZ": "398",
    "KEN": "404",
    "KGZ": "417",
    "KHM": "116",
    "KIR": "296",
    "KNA": "659",
    "KOR": "410",
    "KWT": "414",
    "LAO": "418",
    "LBN": "422",
    "LBR": "430",
    "LBY": "434",
    "LCA": "662",
    "LIE": "438",
    "LKA": "144",
    "LSO": "426",
    "LTU": "440",
    "LUX": "442",
    "LVA": "428",
    "MAC": "446",
    "MAF": "663",
    "MAR": "504",
    "MCO": "492",
    "MDA": "498",
    "MDG": "450",
    "MDV": "462",
    "MEX": "484",
    "MHL": "584",
    "MKD": "807",
    "MLI": "466",
    "MLT": "470",
    "MMR": "104",
    "MNE": "499",
    "MNG": "496",
    "MNP": "580",
    "MOZ": "508",
    "MRT": "478",
    "MSR": "500",
    "MTQ": "474",
    "MUS": "480",
    "MWI": "454",
    "MYS": "458",
    "MYT": "175",
    "NAM": "516",
    "NCL": "540",
    "NER": "562",
    "NFK": "574",
    "NGA": "566",
    "NIC": "558",
    "NIU": "570",
    "NLD": "528",
    "NOR": "578",
    "NPL": "524",
    "NRU": "520",
    "NZL": "554",
    "OMN": "512",
    "PAK": "586",
    "PAN": "591",
    "PCN": "612",
    "PER": "604",
    "PHL": "608",
    "PLW": "585",
    "PNG": "598",
    "POL": "616",
    "PRI": "630",
    "PRK": "408",
    "PRT": "620",
    "PRY": "600",
    "PSE": "275",
    "PYF": "258",
    "QAT": "634",
    "REU": "638",
    "ROU": "642",
    "RUS": "643",
    "RWA": "646",
    "SAU": "682",
    "SDN": "729",
    "SEN": "686",
    "SGP": "702",
    "SGS": "239",
    "SHN": "654",
    "SJM": "744",
    "SLB": "90",
    "SLE": "694",
    "SLV": "222",
    "SMR": "674",
    "SOM": "706",
    "SPM": "666",
    "SRB": "688",
    "SSD": "728",
    "STP": "678",
    "SUR": "740",
    "SVK": "703",
    "SVN": "705",
    "SWE": "752",
    "SWZ": "748",
    "SXM": "534",
    "SYC": "690",
    "SYR": "760",
    "TCA": "796",
    "TCD": "148",
    "TGO": "768",
    "THA": "764",
    "TJK": "762",
    "TKL": "772",
    "TKM": "795",
    "TLS": "626",
    "TON": "776",
    "TTO": "780",
    "TUN": "788",
    "TUR": "792",
    "TUV": "798",
    "TWN": "158",
    "TZA": "834",
    "UGA": "800",
    "UKR": "804",
    "UMI": "581",
    "URY": "858",
    "USA": "840",
    "UZB": "860",
    "VAT": "336",
    "VCT": "670",
    "VEN": "862",
    "VGB": "92",
    "VIR": "850",
    "VNM": "704",
    "VUT": "548",
    "WLF": "876",
    "WSM": "882",
    "XXX": "0",
    "YEM": "887",
    "ZAF": "710",
    "ZMB": "894",
    "ZWE": "716",
}
